//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "property.h"
#include "about.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "MaxEdit"
#pragma link "PPanel"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
	HRESULT (*DirectDrawCreate)(GUID FAR *lpGUID, LPDIRECTDRAW FAR *lplpDD, IUnknown FAR *pUnkOuter);

	lpDD = NULL;
	lpDD2 = NULL;
	lpSurfs = NULL;
	SurfCount = 0;

	DDHinst = LoadLibrary("DDRAW.DLL");
	if(DDHinst == 0)
		return;

	*(FARPROC *)&DirectDrawCreate = GetProcAddress(DDHinst, "DirectDrawCreate");
	if(DirectDrawCreate == NULL)
		return;

	if(FAILED( DirectDrawCreate(NULL, &lpDD, NULL) ))
		return;

	if(FAILED( lpDD->QueryInterface(IID_IDirectDraw2, (void**)&lpDD2) ))
		return;

	lpDD->SetCooperativeLevel(Handle, DDSCL_NORMAL);

	UpdateFreeMemory();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
	Ungrab();

	if(lpDD2) lpDD2->Release();
	if(lpDD)  lpDD->Release();
	if(DDHinst != 0) FreeLibrary(DDHinst);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::UpdateFreeMemory(void)
{
	DWORD dwTotalMem, dwFreeMem;
	DDSCAPS DDSCaps;
	char dummy[16]; // for compiler's bug ???

	if(lpDD2 == NULL) return;

	memset(&DDSCaps, 0, sizeof(DDSCAPS));
	memset(dummy, 0, sizeof(dummy));

	DDSCaps.dwCaps = DDSCAPS_VIDEOMEMORY;
	if(SUCCEEDED( lpDD2->GetAvailableVidMem(&DDSCaps, &dwTotalMem, &dwFreeMem) ))
	{
		PanelTotalMemory->Caption = AnsiString((int)dwTotalMem/1024) + " KB";
		PanelFreeMemory->Caption = AnsiString((int)dwFreeMem/1024) + " KB";
	}

	DDSCaps.dwCaps = DDSCAPS_TEXTURE;
	if(SUCCEEDED( lpDD2->GetAvailableVidMem(&DDSCaps, &dwTotalMem, &dwFreeMem) ))
	{
		PanelTotalTexture->Caption = AnsiString((int)dwTotalMem/1024) + " KB";
		PanelFreeTexture->Caption = AnsiString((int)dwFreeMem/1024) + " KB";
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
	if(Visible)
		UpdateFreeMemory();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MenuPropertyClick(TObject *Sender)
{
	DlgProperty = new TDlgProperty(Application);
	DlgProperty->ShowModal();
	Timer1->Interval = DlgProperty->EditTimer->GetPosition() * 1000;
	delete DlgProperty;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BtnGrabClick(TObject *Sender)
{
	if(BtnGrab->Down)
		Grab(EditMemory->GetPosition() * 1024);
	else
		Ungrab();

	UpdateFreeMemory();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Grab(double size)
{
	if(lpDD == NULL)
		return;

	Ungrab();

	DDSURFACEDESC ddsd;

	SurfCount = 0;
	for(int last=size; last>0; )
	{
		lpSurfs = (LPDIRECTDRAWSURFACE *)realloc(lpSurfs, sizeof(void*) * (SurfCount+1));

		memset(&ddsd, 0, sizeof(ddsd));
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
		ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_VIDEOMEMORY;
		if(last >= 1024*1024)
			ddsd.dwHeight = ddsd.dwWidth = 256;
		else if(last >= 512*512)
			ddsd.dwHeight = ddsd.dwWidth = 128;
		else if(last >= 256*256)
			ddsd.dwHeight = ddsd.dwWidth = 64;
		else
			ddsd.dwHeight = ddsd.dwWidth = 32;

		HRESULT hr = lpDD->CreateSurface(&ddsd, &lpSurfs[SurfCount], NULL);
		if(SUCCEEDED(hr))
		{
			if(SUCCEEDED(lpSurfs[SurfCount]->GetSurfaceDesc(&ddsd)))
			{
				last -= ddsd.lPitch * ddsd.dwHeight;
			} else {
				last -= 128*128;
			}
			SurfCount++;
		} else {
			lpSurfs[SurfCount] = NULL;
			break;
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Ungrab(void)
{
	if(lpSurfs != NULL)
	{
		for(int i=0; i<SurfCount; i++){
			if(lpSurfs[i] != NULL){
				lpSurfs[i]->Release();
			}
		}
		free(lpSurfs);
		lpSurfs = NULL;
	}
	SurfCount = 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MenuAboutClick(TObject *Sender)
{
	DlgAbout = new TDlgAbout(Application);
	DlgAbout->ShowModal();
	delete DlgAbout;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MenuExitClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
